     h dftactgrp(*no) actgrp(*caller)
     h COPYRIGHT('20 MadSlammer <Peter@Colpaert-VanMenxel.be>')
     h debug(*yes) alwnull(*inputonly)
      //
     d vApiErrDs       ds
     d  vbytpv                       10i 0 inz(%len(vApiErrDs))                 bytes provided
     d  vbytav                       10i 0 inz(0)                               bytes returned
     d  vmsgid                        7a                                        error msgid
     d  vresvd                        1a                                        reserved
     d  vrpldta                     128a                                        replacement data
      //
     D mMsgRtv         ds                  inz
     D mMsgRtvLen              9     12i 0                                      length msg retrieved
     D mMsgMessage            25    256                                         message retrieved
     D mMsgLen         s             10i 0 inz(%len(mMsgRtv))                   length of message
     d  Msgmic         s              7a
     d  Msgfil         s             20a
     d  MsgDta         s          32767a
     d  MsgLen         s             10i 0
     d  Msgtyp         s             10a
     d  Msgpgq         s             10a
     d  Msgstk         s             10i 0
     d  Msgkey         s              4a
      //
     d  SpaceName      s             20a   Inz('WRKFLD    QTEMP')
     d  ExtAttr        s             10    Inz(*blanks)
     d  InitSize       s             10i 0 Inz(32000)
     d  InitVal        s              1    Inz(X'00')
     d  Auth           s             10    Inz('*ALL')
     d  Text           s             50    Inz(*blanks)
     d  Replace        s             10    Inz('*YES')
     d  ListFormat     s             10    Inz('FLDL0100')
     d  Override       s              1    Inz('0')
      //
      //
      //*************************************************************************
      // Prototyped calls                                                       *
      //*************************************************************************
     d CrtUsrSpc       PR                  ExtPgm('QUSCRTUS')                   Create User Space
     d                               20                                         Qualified Name
     d                               10                                         Extended Attribute
     d                               10i 0                                      Initial Size
     d                                1                                         Initial Value
     d                               10                                         Public Authority
     d                               50                                         Description
     d                               10                                         Replace
     db                                    like(vApiErrDS)
      //
     d LstFld          PR                  ExtPgm('QUSLFLD')                    List Fields
     d                               20                                         User Space Name
     d                                8                                         Format Name
     d                               20                                         File Nam
     d                               10                                         Record Format Name
     d                                1                                         Override Processing
     db                                    like(vApiErrDS)
      //
     d SndMsg          PR                  ExtPgm('QMHSNDPM')                   Send Program Message
     d                                7                                         Message ID
     d                               20                                         Message File
     d                            32767                                         Text
     d                               10i 0                                      Length
     d                               10                                         Type
     d                               10                                         Queue
     d                               10i 0                                      Stack Entry
     d                                4                                         Key
     db                                    like(vApiErrDS)
      //
     d RtvMsg          PR                  ExtPgm('QMHRTVM')                    Retrieve Message
     d                              256                                         Message Retrieved
     d                               10i 0                                      Length of Message
     d                                8    const                                Requested format
     d                                7                                         Message ID
     d                               20    const                                Message File
     d                              128                                         Replacement Data
     d                               10i 0 const                                Length of Repl. Data
     d                               10    const                                Substitution Char
     d                               10    const                                Format Control Char
     db                                    like(vApiErrDS)
      //
     d DltUsrSpc       PR                  ExtPgm('QUSDLTUS')                   Delete User Space
     d                               20                                         Qualified Name
     db                                    like(vApiErrDS)
      //
      //*************************************************************************
      //
     d WrkFldrV        pr
     d                               20a
     d                               10a
      //
     d WrkFldrV        pi
     d  Fillib                       20a
     d  RecFormat                    10a
      //
      /FREE
       CrtUsrSpc(
           SpaceName:
           ExtAttr:
           InitSize:
           InitVal:
           Auth:
           Text:
           Replace:
           vApiErrDs);
       //
       LstFld(
           SpaceName:
           ListFormat:
           FilLib:
           RecFormat:
           Override:
           vApiErrDs);
       //
       If vBytav <> *zeros;
         RtvMsg(
             mMsgRtv :
             mMsgLen :
             'RTVM0100':
             vmsgid:
             'QCPFMSG   *LIBL':
             vrpldta:
             %len(vrpldta):
             '*YES      ':
             '*NO       ':
             vApiErrDs);
         if mMsgRtvLen > %len(mMsgMessage);
           mMsgRtvLen = %len(mMsgMessage);
         endif;
         //
         Msgfil = 'QCPFMSG   *LIBL';
         MsgDta = '0000' + vmsgid +': ' +
             %subst(mMsgMessage:1:mMsgRtvLen);
         msgmic = 'CPD0006';
         //
         MsgLen = %len(%trim(MsgDta));
         Msgtyp = '*DIAG';
         Msgpgq = '*CTLBDY';
         Msgstk = 1;
         Msgkey = '    ';
         //
         reset vApiErrDs;
         SndMsg(
             msgmic:
             msgfil:
             Msgdta:
             MsgLen:
             Msgtyp:
             Msgpgq:
             Msgstk:
             Msgkey:
             vApiErrDs);
         //
         msgmic = 'CPF0002';
         Msgfil = 'QCPFMSG   *LIBL';
         MsgDta =  *blanks;
         //
         MsgLen = %len(MsgDta);
         Msgtyp = '*ESCAPE';
         Msgstk = 1;
         Msgkey = '    ';
         //
         DltUsrSpc(
             SpaceName:
             vApiErrDs);
         //
         reset vApiErrDs;
         SndMsg(
             msgmic:
             msgfil:
             Msgdta:
             MsgLen:
             Msgtyp:
             Msgpgq:
             Msgstk:
             Msgkey:
             vApiErrDs);
         //
       Endif;
       //
       *inlr = *on;
       Return;
      /END-FREE
